Attribute VB_Name = "Module1"
Global PrgRun As Boolean 'Flag = Programm luft

Public Texture(15) As GLuint 'Handle der Texturen

Private hrc As Long 'Handle fr den OpenGL Gertekontext

Public Type BITMAPINFOHEADER 'Struktur des Infobereichs einer Bitmap
  biSize As Long 'bestimmt die Anzahl von Bytes, die von der BITMAPINFOHEADER-Struktur bentigt werden
  biWidth As Long 'bestimmt die Breite der Bitmaps in Pixel
  biHeight As Long 'bestimmt die Hhe der Bitmaps in Pixel
  biPlanes As Integer 'bestimmt die Anzahl der Farbebenen (normalerweise 1)
  biBitCount As Integer 'bestimmt die Anzahl der Bits pro Pixel
  biCompression As Long 'bestimmt den Kompressionstyp fr ein komprimiertes Bitmap
  biSizeImage As Long 'bestimmt die Bildgre in Bytes, ohne BITMAPINFOHEADER und RGBQUAD-Strukturen
  biXPelsPerMeter As Long 'bestimmt die horizontale Auflsung des Bitmaps fr das Zielgert in Pixel pro Meter
  biYPelsPerMeter As Long 'bestimmt die vertikale Auflsung des Bitmaps fr das Zielgert in Pixel pro Meter
  biClrUsed As Long 'bestimmt die Anzahl der Farbindizes in der Farbpalette, die gerade vom Bitmap verwendet wird
  biClrImportant As Long 'bestimmt die Anzahl der Farbindizes, die fr die Darstellung des Bitmaps fr unabdingbar erachtet werden
End Type

Public Type RGBQUAD 'Struktur fr 3 Farben = 3 Byte + 1 Reserve
  rgbBlue As Byte 'Blau
  rgbGreen As Byte 'Grn
  rgbRed As Byte 'Rot
  rgbReserved As Byte 'ungenutzt
End Type


Public Sub Main()
   Static tGlid As GLfloat 'Schritte, um die eine Texture verschoben wird
   Dim PicPos As GLfloat 'Position des Einzelbildes in der Gesamtgrafik
   Dim Piclength As GLfloat 'Breite einer Einzelgrafik
   Dim Pic As GLfloat 'Zhler fr den Counter
   
   Dim frm As Form
   PrgRun = True 'Flag = das Programm luft
   Set frm = New Form1 'Fenster fr OpenGL-Ausgabe
   frm.ScaleMode = vbPixels 'das Fenster mu zwingend in Pixel bemessen werden

   If CreateGLWindow(frm, 640, 480, 16) Then 'Fenster initialisieren
      Do 'Endlosschleife in der das Fenster laufend gelscht und neu aufgebaut wird.
         'Die Laufzeit dieser Schleife ist ausschlaggebend, wieviele Objekt gezeichnet werden knnen
         glClear clrColorBufferBit Or clrDepthBufferBit ' lscht das Fenster und den Tiefenpuffer
         glLoadIdentity 'setzt die aktuelle Modell-Matrix zurck

         glTranslatef -1#, 0#, -8# 'Zeichenpunkt setzen
         
         glBindTexture GL_TEXTURE_2D, Texture(1) 'Auswahl der gewnschten Textur
         glBegin bmQuads 'Fensterrahmen
            glTexCoord2f 1#, 1#: glVertex3f 2#, 2#, 1# 'Oben Rechts
            glTexCoord2f 0#, 1#: glVertex3f -2#, 2#, 1# 'Oben Links
            glTexCoord2f 0#, 0#: glVertex3f -2#, -2#, 1# 'Unten Links
            glTexCoord2f 1#, 0#: glVertex3f 2#, -2#, 1# 'Unten Rechts
         glEnd 'Ende des Fensterrahmens
         
         glMatrixMode GL_TEXTURE 'Umschalten in die Texture-Matrix
            glLoadIdentity 'setzt die aktuelle Texture-Matrix zurck
            glTranslatef tGlid, 0, 0 'verschiebt die aktuelle Textur entlang der X-Achse
            'OpenGL setzt automatisch den 'berstehenden' Teil wieder an
         glMatrixMode GL_MODELVIEW 'und zurck in den Modell-Matrix
         
         glBindTexture GL_TEXTURE_2D, Texture(2) 'Auswahl der gewnschten Textur
         glBegin bmQuads 'Fensterscheibe
            glTexCoord2f 1#, 1#: glVertex3f 1.335, 1.49, 1# 'Oben Rechts
            glTexCoord2f 0#, 1#: glVertex3f -1.3, 1.49, 1#   'Oben Links
            glTexCoord2f 0#, 0#: glVertex3f -1.3, -1.4, 1#   'Unten Links
            glTexCoord2f 1#, 0#: glVertex3f 1.335, -1.4, 1#   'Unten Rechts
         glEnd 'Ende der Fensterscheibe
         
         glMatrixMode GL_TEXTURE 'Umschalten in die Texture-Matrix
            glLoadIdentity 'setzt die aktuelle Texture-Matrix zurck
         glMatrixMode GL_MODELVIEW 'und zurck in den Modell-Matrix
         
         glLoadIdentity 'setzt die aktuelle Modell-Matrix zurck
         glTranslatef 2#, 0#, -8# 'Zeichenpunkt setzen
         
         Piclength = 1 / 8 'das Bild besteht aus 8 Einzelbildern
         PicPos = Round(Pic) * Piclength 'errechnen, an welcher Position das Einzelbild steht
         
         glBindTexture GL_TEXTURE_2D, Texture(3) 'Auswahl der gewnschten Textur
         glBegin bmQuads 'Begin Zhler
            glTexCoord2f PicPos + Piclength, 1#: glVertex3f 0.5, 0.5, 1#   'Oben Rechts
            glTexCoord2f PicPos, 1#: glVertex3f -0.5, 0.5, 1#   'Oben Links
            glTexCoord2f PicPos, 0#: glVertex3f -0.5, -0.5, 1#   'Unten Links
            glTexCoord2f PicPos + Piclength, 0#: glVertex3f 0.5, -0.5, 1#   'Unten Rechts
         glEnd 'Ende des Zhlers
         
         Pic = Pic + 0.001 'langsames Hochzhlen, damit der Zhler bei schnellen Rechnern nicht rast.
         
         SwapBuffers (frm.hDC) 'Puffer tauschen (Double Buffering)
         DoEvents

         tGlid = tGlid + 0.00005 'der Wert zum verschieben ist Rechnerabhngig! Einfach mal austesten.
      Loop While PrgRun 'Programm nur beenden, wenn PrgRun = False
      'PrgRun ist Global definiert und wird im KeyDown-Ereignis von Form1 bei drcken von Escape gesetzt.
      
      'alles freigeben und Programm beenden
      If hrc <> 0 Then 'hatten wir einen Gertekontext fr OpenGL?
         wglMakeCurrent 0, 0 'Freigeben des Gertekontexts
         wglDeleteContext (hrc) 'Freigeben des Renderingkontexts
      End If
      Unload frm
      Set frm = Nothing
      End
   End If
End Sub

Public Function CreateGLWindow(frm As Form, Width As Integer, Height As Integer, Bits As Integer) As Boolean
   Dim pfd As PIXELFORMATDESCRIPTOR ' pfd erklrt Windows, wie das Fenster beschaffen sein soll
   Dim PixelFormat As GLuint ' enthlt das Ergebnis vom Versuch, ein Fenster mit den gegebenen Parametern zu erstellen
      
   pfd.cColorBits = Bits 'Farbtiefe
   pfd.cDepthBits = 16 '16 Bit Tiefenpuffer
   'Der Tiefenpuffer enthlt die Entfernung eines Pixels zur Kamera (Betrachter).
   'Er verhindert, da Objekte im Hintergrund beim Zeichnen Objekte im Vordergund berlagern.
   pfd.dwFlags = PFD_DRAW_TO_WINDOW Or PFD_SUPPORT_OPENGL Or PFD_DOUBLEBUFFER
   'PFD_DRAW_TO_WINDOW = das Format mu als Fenster sichtbar sein knnen
   'PFD_SUPPORT_OPENGL = das Format mu OpenGL untersttzen
   'PFD_DOUBLEBUFFER = das Foramt mu Double Buffering untersttzen
   pfd.iLayerType = PFD_MAIN_PLANE 'Die Hauptebene auf der gezeichnt wird.
   pfd.iPixelType = PFD_TYPE_RGBA 'Pixel werden im RGBA Modus dargestellt.
   'RGB ist mit VB identisch. Fr A wird ein Alpha-Wert fr die Transparenz bergeben
   pfd.nSize = Len(pfd) 'Gre der Struktur sollte natrlich stimmen
   pfd.nVersion = 1 'Versionsnummer

   PixelFormat = ChoosePixelFormat(frm.hDC, pfd) 'Windows nach einem oben beschriebenen Pixelformat fragen
   If PixelFormat <> 0 Then
      'Windows hat ein entsprechendes Format gefunden
      If SetPixelFormat(frm.hDC, PixelFormat, pfd) <> 0 Then
         'Einrichten des Pixelformates war erfolgreich
         hrc = wglCreateContext(frm.hDC)
         If hrc <> 0 Then
            'ein Rendering Kontext wurde erstellt
            If wglMakeCurrent(frm.hDC, hrc) <> 0 Then
               'Der Kontext wurde aktiviert
               frm.Show 'Fenster anzeigen
               Call LoadTextureS(App.Path & "\fenster.bmp", 1) 'laden und erzeugen eines Textures
               Call LoadTextureS(App.Path & "\wolkene.bmp", 2) 'laden und erzeugen eines weiteren Textures
               Call LoadTextureS(App.Path & "\nummern.bmp", 3) 'laden und erzeugen eines weiteren Textures
               glEnable glcTexture2D 'Einschalten des Texture Mappings
               glShadeModel smSmooth 'schaltet schne Farbbergange ein
               glClearColor 0#, 0#, 0#, 0# 'schwarzer Hintergrund
               glClearDepth 1# 'Tiefenpuffer zurcksetzten (spter mehr)
               glEnable glcDepthTest 'Aktivierung des Tiefentests (spter mehr)
               glDepthFunc cfLEqual 'Typ des Tiefentests (spter mehr)
               glHint htPerspectiveCorrectionHint, hmNicest 'Art der Perspectivenansicht
               'hmNicest = beste Ansicht / hmFastest = schnellste Darstellung
               CreateGLWindow = True
            End If
         End If
      End If
   End If
End Function

Public Sub ReSizeGLScene(ByVal Width As GLsizei, ByVal Height As GLsizei)
   'Anpassen der Gre und Initialisierung des OpenGL-Fensters
   If Height = 0 Then 'Die Fensterhhe mu grer 0 sein
       Height = 1 'sonst kommt es zu einem Division by Zero Fehler
   End If
   glViewport 0, 0, Width, Height 'leeren des aktuellen Viewports
   glMatrixMode mmProjection 'Auswahl der Projektionsmatrix
   glLoadIdentity 'setzt die aktuelle Modell-Matrix zurck

   gluPerspective 45#, Width / Height, 0.1, 100# 'Berechnung des aktuellen Seitenverhltnisses des Fensters

   glMatrixMode mmModelView 'Auswahl der Modelview Projektionsmatrix
   glLoadIdentity 'setzt die aktuelle Modell-Matrix zurck
End Sub



Public Function LoadTexture(ByVal Filename As String, ByVal Index As Long) As Boolean
   Dim H As Long, W As Long 'Hhe und Breite der Grafik
   Dim X As Long, Y As Long 'Zhlvariablen
   Dim C As Long 'Farbwert eines Punktes als Long
   Dim Ypos As Long 'Korrigierte Y-Position fr Array
   Dim TextureImg() As GLbyte
   
   'Vorraussetzungen:
   'Die Grafik mu quadratisch sein!
   'Die Seitenlnge der Grafiken mssen 2er Potenzen entsprechen:
   '16,32,64,128,256,512,1024 Pixel etc.
   'Durch den Umweg ber die Picturebox sind aber auch Formate wie jpg oder gif mglich.
   'Die Autosize-Eigenschaft der Picturebox mu auf True stehen!
   
   Form1.Picture1.Picture = LoadPicture(Filename) 'Bild laden
   
   H = Form1.Picture1.ScaleHeight 'Hhe der Grafik bernehmen
   W = Form1.Picture1.ScaleWidth 'Breite der Grafik bernehmen
   
   ReDim TextureImg(2, H - 1, W - 1) 'Speicher fr die Bilddaten reservieren
   
   'Alle Bildpunkte werden in das Array TextureImg() bertragen
   For X = 0 To W - 1 'in einer doppelten Schleife die Farbe jedes Bildpunktes erfassen
       For Y = 0 To H - 1
           C = Form1.Picture1.Point(X, Y) 'gibt die Farbe des Punkte als Long-Wert zurck
           Ypos = H - Y - 1 'Konvertieren der Y-Position
           Call CopyMemory(TextureImg(0, X, Ypos), C, 3) 'schnelle Zerlegung des Long-Wertes in RGB-Farben
           'beruht auf Tip 427: Farbwert in RGB schneller auflsen II
       Next
   Next
   
   glGenTextures 1, Texture(Index)  'kreiert eine Textur
   glBindTexture glTexture2D, Texture(Index) 'Zuweisung: die Textur ist 2D
   'Generieren der eigentlichen Texture in OpenGL
   glTexImage2D glTexture2D, 0, 3, W, H, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImg(0, 0, 0)
   'Der 1. Parameter besagt wieder 2D Texture
   'Der 2. Parameter gibt den Grad der Details an, ist aber vorerst einmal unwichtig
   'Der 3. Parameter gibt die Art der Farbkanle an, 3 = RGB.
   'Parameter 4 und 5 sind Breite und Hhe der Texture
   'Der 6. Parameter gibt die Rahmenbreite an, vorerst aber mal 0.
   'Parameter 7 und 8 geben Farbformat (RGB) und Art der Daten (Unsigned Byte = 0 - 255) an.
   'Der letzte Parameter bergibt schluendlich die eigentliche Textur.
   
   'Diese Zeilen legen fest, welcher Filter verwendet werden soll:
   glTexParameteri glTexture2D, tpnTextureMinFilter, GL_LINEAR
   glTexParameteri glTexture2D, tpnTextureMagFilter, GL_LINEAR
   'tpnTextureMinFilter besagt, mit welchem Filter die Grafik zusammengedrckt werden soll.
   'tpnTextureMagFilter besagt, mit welchem Filter die Grafik auseinandergezogen wird.
   'Der Parameter GL_LINEAR erzeugt das beste Ergebnis, belastet aber den Prozessor.
   'Mglich wre auch GL_NEAREST. Das entlastet zwar die Hardware, sieht aber schnell recht pixelig aus.
   
   Erase TextureImg 'Der Speicher wird nicht mehr gebraucht.
End Function



Public Function LoadTextureS(ByVal Filename As String, ByVal Index As Long) As Boolean
   Dim F As Long 'Dateihandle
   Dim BmpFile As BITMAPFILEHEADER 'Fileheader-Struktur einer Bitmap
   Dim BmpInfo As BITMAPINFOHEADER 'Info-Struktur einer Bitmap
   Dim BmpRGB() As RGBQUAD 'RGB Struktur = 4 Byte = 3 Farben und 1 Reserve
   Dim BmpImageSize As Long 'Gre der Bitmap in Byte
   Dim BmpPixelSize As Integer 'Gre der Daten eines Pixels in Byte
   Dim BmpImageData() As Byte 'Array fr die eigentlichen Bitmapdaten
   
   F = FreeFile 'freie Dateinummer abholen
   Open Filename For Binary As #F 'Bitmap im Binr-Modus ffnen
   
   Get #F, , BmpFile 'Fileheader-Struktur / brauchen wir aber nicht!
   Get #F, , BmpInfo 'Struktur der Bitmap

   'wenn die Farbtiefe weniger als 24 Bit betrgt mu die Gre des Arrays angepat werden.
   'aus Grunden der Kompatibilitt sollten die verwendeten Bitmaps aber immer 24-Bit Farbtiefe haben.
   If (BmpInfo.biBitCount < 24) Then
      ReDim BmpRGB(BmpInfo.biClrUsed) 'anpassen des Arrays
      Get #F, , BmpRGB 'einlesen der Farbdaten
   End If

   BmpPixelSize = BmpInfo.biBitCount / 8 'Anzahl der Bytes fr Farbe je Pixel
  
   BmpImageSize = BmpInfo.biWidth * BmpInfo.biHeight * BmpPixelSize 'Gesamtgre der Bitmap
   ReDim BmpImageData(BmpImageSize) 'Array an Gesamtgre der Bitmap anpassen
   
   Get #F, , BmpImageData 'einlesen der Bitmap und schon haben wir die Daten fr OpenGL im Speicher
   
   Close #F

   glGenTextures 1, Texture(Index)  'kreiert eine Textur
   glBindTexture glTexture2D, Texture(Index) 'Zuweisung: die Textur ist 2D
   'Generieren der eigentlichen Texture in OpenGL
   glTexImage2D glTexture2D, 0, 3, BmpInfo.biWidth, BmpInfo.biHeight, 0, tiBGRExt, GL_UNSIGNED_BYTE, BmpImageData(0)
   'Der 1. Parameter besagt wieder 2D Texture
   'Der 2. Parameter gibt den Grad der Details an, ist aber vorerst einmal unwichtig
   'Der 3. Parameter gibt die Art der Farbkanle an, 3 = RGB.
   'Parameter 4 und 5 sind Breite und Hhe der Texture und stammen aus der Info-Struktur der Bitmap
   'Der 6. Parameter gibt die Rahmenbreite an, vorerst aber mal 0.
   'Parameter 7 und 8 geben Farbformat (erweitertes RGB Format einer Bitmap) und Art der Daten (Unsigned Byte = 0 - 255) an.
   'Der letzte Parameter bergibt schluendlich die eigentliche Textur.
   
   'Diese Zeilen legen fest, welcher Filter verwendet werden soll:
   glTexParameteri glTexture2D, tpnTextureMinFilter, GL_LINEAR
   glTexParameteri glTexture2D, tpnTextureMagFilter, GL_LINEAR
   'tpnTextureMinFilter besagt, mit welchem Filter die Grafik zusammengedrckt werden soll.
   'tpnTextureMagFilter besagt, mit welchem Filter die Grafik auseinandergezogen wird.
   'Der Parameter GL_LINEAR erzeugt das beste Ergebnis, belastet aber den Prozessor.
   'Mglich wre auch GL_NEAREST. Das entlastet zwar die Hardware, sieht aber schnell recht pixelig aus.
   
   Erase BmpImageData 'Speicher freigen
   Erase BmpRGB
End Function




